include "VVram.inc"
include "Vram.inc"
include "Chars.inc"

ext AsciiPatternSource_, MonoPatternSource_, ColorPatternSource_
ext VVramFront_, RowFlags_

AsciiCount equ 64

dseg
Backup:
    defs VVramWidth*VVramHeight
AsciiPattern: public AsciiPattern
    defs CharHeight*4*AsciiCount
MonoPattern: public MonoPattern
    defs CharHeight*2*Char_End


; void InitAsciiPattern();
cseg
InitAsciiPattern_: public InitAsciiPattern_
    push af | push hl | push de | push bc
        ld hl,AsciiPattern
        ld de,AsciiPatternSource_
        ld c,AsciiCount
        do
            ld b,CharHeight
            do
                ld a,(de) | inc de
                push de | push bc
                    ld d,a
                    ld b,4
                    do
                        ld c,70h
                        xor a
                        do
                            sla d
                            if c
                                or c
                            endif
                            srl c | srl c | srl c | srl c
                        while nz | wend
                        ld (hl),a | inc hl
                    dwnz
                pop bc | pop de
            dwnz
            dec c
        while nz | wend
    pop bc | pop de | pop hl | pop af
ret


; void InitMonoPattern();
cseg
Colors:
    defb 4,03h
    defb 3,07h
    defb 1,06h
    defb 0
InitMonoPattern_: public InitMonoPattern_
    push af | push hl | push de | push bc
        ld hl,MonoPattern
        ld de,MonoPatternSource_
        ld bc,Colors
        do
            ld a,(bc) | inc bc
            or a
        while nz
            push af
                ld a,(bc) | inc bc ; color
                exx
                    ld d,a ; back color
                    srl d | srl d | srl d | srl d
                    and 0fh
                    ld e,a ; fore color
                exx
            pop af
            push bc
                ld b,a ; count
                do
                    ld c,CharHeight/2
                    do
                        ld a,(de) | inc de
                        push de | push bc
                            exx
                                ld b,a
                            exx
                            ld c,4
                            do
                                exx
                                    ld c,0
                                exx
                                ld b,2
                                do
                                    exx
                                        sla c | sla c | sla c | sla c
                                        sla b
                                        if c
                                            ex af,af'
                                                ld a,c
                                                or e
                                                ld c,a
                                            ex af,af'
                                        else
                                            ex af,af'
                                                ld a,c
                                                or d
                                                ld c,a
                                            ex af,af'
                                        endif
                                    exx
                                dwnz
                                exx
                                    ld a,c
                                exx
                                ld (hl),a | inc hl
                                dec c
                            while nz | wend
                        pop bc | pop de
                        dec c
                    while nz | wend
                dwnz
            pop bc
        wend
    pop bc | pop de | pop hl | pop af
ret


; void ClearScreen();
ClearScreen_: public ClearScreen_
    push af | push hl | push de | push bc
        ld hl,Vram
        ld de,8000h
        do
            ld b,l
            ld c,h
            xor a
            out (c),a
            inc hl
            dec de
            ld a,e
            or d
        while nz | wend

        ld hl,Backup
        ld bc,VVramWidth*VVramHeight
        do
            ld (hl),0
            inc hl
            dec bc
            ld a,c
            or b
        while nz | wend
    pop bc | pop de | pop hl | pop af
ret


; word PrintC(word vram, byte c);
PrintC_: public PrintC_
    push af | push hl | push de | push bc
        ld a,e
        sub ' '
        add a,a ;*2
        add a,a ;*4
        ex de,hl
            ld l,a
            ld h,0
            add hl,hl ;*8
            add hl,hl ;*16
            add hl,hl ;*32
            ld bc,AsciiPattern
            add hl,bc
        ex de,hl
        ld b,l
        ld c,h
        ld l,CharHeight
        do
            ld h,4
            do
                ld a,(de) | inc de
                out (c),a
                inc b
                dec h
            while nz | wend
            ld a,b
            sub 4
            ld b,a
            ld a,c
            add a,10h
            ld c,a
            dec l
        while nz | wend
    pop bc | pop de | pop hl | pop af
    inc hl | inc hl | inc hl | inc hl
ret


cseg
PatternAddressDE:
    ex de,hl
        cp Char_Enemy
        if c
            ld bc,MonoPattern
        else
            sub Char_Enemy
            ld bc,ColorPatternSource_
        endif
        ld l,a
        ld h,0
        add hl,hl ;*2
        add hl,hl ;*4
        add hl,hl ;*8
        add hl,hl ;*16
        add hl,bc
    ex de,hl
ret

PutN:
    do
        ex af,af'
            ld a,(de) | inc de
            out (c),a | inc b
            ld a,(de) | inc de
            out (c),a | dec b
            ld a,c
            add a,10h
            ld c,a
        ex af,af'
        dec a
    while nz | wend
ret

ClearN:
    do
        ex af,af'
            xor a
            out (c),a | inc b
            out (c),a | dec b
            ld a,c
            add a,10h
            ld c,a
        ex af,af'
        dec a
    while nz | wend
ret

AddDE:
    add a,e
    ld e,a
    ld a,d
    adc a,0
    ld d,a
ret


; word Put(word vram, byte c);
cseg
Put_: public Put_
    push af | push hl | push de | push bc
        ld a,e
        call PatternAddressDE
        ld b,l
        ld c,h
        ld a,CharHeight
        call PutN
    pop bc | pop de | pop hl | pop af
    inc hl | inc hl
ret


VVramToVramRow:     public VVramToVramRow
    exx
        push de | push bc
    exx

    ld b,VVramWidth/2
    do 
        push bc
            ld a,(de) | inc de
            ld c,a
            cp (hl)
            if nz
                ld (hl),a | inc hl
                ld a,(de) | inc de
                ld b,a
                ld (hl),a | inc hl
                jr rowput
            else
                inc hl
                ld a,(de) | inc de
                ld b,a
                cp (hl)
                if nz
                    ld (hl),a | inc hl
                    rowput:
                    ld a,c
                    or a
                    if z
                        exx
                            ld b,l
                            ld c,h
                            ld a,8
                            call ClearN
                        exx
                    else
                        exx
                            call PatternAddressDE
                        exx
                        ld a,b
                        exx
                            ld b,l
                            ld c,h
                            or a
                            if z
                                ld a,CharHeight
                                call PutN
                                jr rowputend
                            endif
                            dec a
                            if z
                                ld a,CharHeight/2
                                call ClearN
                                ld a,CharHeight/2
                                call PutN
                                jr rowputend
                            endif
                            dec a
                            if z
                                ld a,2*CharHeight/2
                                call AddDE
                                ld a,CharHeight/2
                                call PutN
                                ld a,2*CharHeight*3
                                call AddDE
                                ld a,CharHeight/2
                                call PutN
                            else
                                ld a,2*CharHeight/2
                                call AddDE
                                ld a,CharHeight/2
                                call PutN
                                ld a,CharHeight/2
                                call ClearN
                            endif
                            rowputend:
                        exx
                    endif
                else
                    inc hl
                endif
                exx
                    inc hl
                    inc hl
                exx
            endif
        pop bc
    dwnz
    exx
        ld bc,20h
        add hl,bc

        pop bc | pop de
    exx
ret


; void VVramToVramAll();
VVramToVramAll_: public VVramToVramAll_
    push af | push hl | push de | push bc
        ld de,VVramFront_
        ld hl,Backup
        exx
            ld hl,Vram
        exx
        ld c,VVramHeight
        do
            call VVramToVramRow
            dec c
        while nz | wend
    pop bc | pop de | pop hl | pop af
ret


; void VVramToVramChanged();
VVramToVramChanged_: public VVramToVramChanged_
    push af | push hl | push de | push bc
        ld de,VVramFront_
        ld hl,Backup
        exx
            ld hl,Vram
            ld de,RowFlags_
            ex de,hl
                ld c,1
                ld b,(hl)
                inc hl
            ex de,hl
        exx
        ld c,VVramHeight ; vertical count    
        do
            exx
                ld a,b
                and c
            exx
            if nz
                call VVramToVramRow            
            else
                push bc
                    ld bc,VVramWidth
                    add hl,bc
                    ex de,hl
                        add hl,bc
                    ex de,hl
                pop bc
                exx
                    push bc
                        ld bc,VramRowSize
                        add hl,bc
                    pop bc
                exx
            endif
            exx
                sla c
                if z
                    ex de,hl
                        ld c,1
                        ld b,(hl)
                        inc hl
                    ex de,hl
                endif
            exx
            dec c
        while nz | wend

        xor a
        ld (RowFlags_),a
        ld (RowFlags_+1),a
        ld (RowFlags_+2),a
    pop bc | pop de | pop hl | pop af
ret
